Create elevations based on scope box with Python

Hello All,

I’m encountering an issue while trying to create new elevation views based on the outlines of a scope box. The script works perfectly in Dynamo 1.3.4.6 (Revit 2019) but fails to produce the expected results in Dynamo 3.3 (Revit 2025)

Overview of the Workflow:

  1. user selects a scope box in Revit
  2. outlines of the scope box are extracted
  3. midpoints position of the outlines are used for placing elevation markers
  4. Python script generates four elevation views for each selected scope box based on this logic

Issue in Dynamo 3.3:

  • In Dynamo 1.3, the [PolyCurve.Curves] node outputs a list of Curves, and the Python script correctly creates all four elevation views.
  • In Dynamo 3.3, the same logic results in the [PolyCurve.Curves] node outputting a list of Lines instead of Curves
  • As a result, the Python script only creates 1 elevation view instead of 4, and I suspect the issue lies in how the Python script handles the Lines.
  • I do not have any experience working with Python, so I don’t really know how to resolve this further… Any help would be greatly appreciated!

Here’s a screenshot comparing the output behavior in Dynamo 1.3 and Dynamo 3.3 for the same input:

This most likely prevented the python script to run correctly, I presume it only wants Curves.(even though Lines essentially are curves as well)
Is it possible to modify the Python script to properly handle Lines? Or is it possible to convert Lines to Curves before feeding into Python?

I’m a new user so I can’t upload my dyn files directly here. So I have uploaded them here instead.
DYN

here’s just the python script
https://pym.dev/p/26fcp/

Any help would be greatly appreciated. Thank you in advance!

Hi @N.G and welcome !

The issue comes from the fact that you used to use IronPython and now CPython3 (PythonNet) where each object must be correctly typed (cast)

Here is the corrected Python code

import clr
import System
from System.Collections.Generic import List
clr.AddReference('RevitAPI')
clr.AddReference("RevitServices")
clr.AddReference("RevitNodes")
import RevitServices
import Revit
clr.ImportExtensions(Revit.GeometryConversion)

import Autodesk
import  Autodesk.Revit.DB as DB
from Autodesk.Revit.DB import *
from RevitServices.Persistence import DocumentManager
from RevitServices.Transactions import TransactionManager

from math import atan2

doc = DocumentManager.Instance.CurrentDBDocument

toggle = IN[0]
points = UnwrapElement(IN[1])
modelPoints = UnwrapElement(IN[2])
cropCurves = UnwrapElement(IN[3])
viewType = UnwrapElement(IN[4])

lst = []

if toggle == True:

    TransactionManager.Instance.EnsureInTransaction(doc)
    for ind, point in enumerate(points):
    
        modelMP = modelPoints[ind].ToXyz()
        modelMPX = modelMP.X
        modelMPY = modelMP.Y
        
        cropLines = cropCurves[ind]
        l1 = cropLines[0].ToRevitType()
        l2 = cropLines[1].ToRevitType()
        l3 = cropLines[2].ToRevitType()
        l4 = cropLines[3].ToRevitType()
        
        elevationPT = point.ToXyz()
        elptRotate = XYZ(elevationPT.X, elevationPT.Y, elevationPT.Z+100)
        ln = Line.CreateBound(elevationPT, elptRotate)
        
        elevationPTY = elevationPT.Y
        elevationPTX = elevationPT.X
        combY = elevationPTY-modelMPY
        combX = elevationPTX-modelMPX
        ang = atan2(combY, combX)
        
        eleMarker = ElevationMarker.CreateElevationMarker(doc, viewType.Id, elevationPT, 100)
        ele = eleMarker.CreateElevation(doc, doc.ActiveView.Id , 0)
        
        ElementTransformUtils.RotateElement(doc, eleMarker.Id, ln, ang)
        
        crManager = ele.GetCropRegionShapeManager()
        
        newCurveLoop = List[DB.Curve]()
        newCurveLoop.Add(l1)
        newCurveLoop.Add(l2)
        newCurveLoop.Add(l3)
        newCurveLoop.Add(l4)
        cLoop = CurveLoop.Create(newCurveLoop)
        
        lst.append(ele)

    TransactionManager.Instance.TransactionTaskDone()
    OUT = lst
    
else:
    OUT = lst
2 Likes

Thank you @c.poupin! Hopefully it didn’t take too much of your time.

The updated python script now works beautifully!

1 Like